/**
 * NX
 * @author Shogo
 */

public class ShFraction extends ShReal
{
	public static final ShFraction ZERO = new ShFraction(0, 1);
	
	///q
	protected int num;
	
	///
	protected int den;
	
	protected ShFraction(int num, int den)
	{
		this.num = num;
		this.den = den;
	}
	
	/**
	 * ^ꂽƓShFractionIuWFNg쐬B
	 * 쐬łȂꍇShFloatIuWFNgԂB
	 * @param value l
	 */
	public static ShReal getFraction(long value)
	{
		return getFraction(value, 1);
	}
	
	/**
	 * qƕw肵ĕ쐬B
	 * ShFractionƂč쐬łȂꍇ́AShFloatIuWFNgԂ
	 * @param num q
	 * @param den 
	 */
	public static ShReal getFraction(long num, long den)
	{
		return getFraction(num, den, 0);
	}
	
	/**
	 * num/den*10^exp̌`̕쐬B
	 */
	public static ShReal getFraction(long num, long den, int exp)
	{
		long bak_num = num, bak_den = den;
		//^ꂽ̐Ks
		
		//ꂪKɂȂ悤ɂ
		if(den<0)
		{
			den = -den;
			num = -num;
		}
		
		if(num==0) {
			//00/1ŕ\
			return ZERO;
		}
		else if(den==0)
		{
			throw new ArithmeticException("0ŏZ܂.");
		}
		

		//qEő񐔂Ŋ
		long g = gcd(num, den);
		num /= g;
		den /= g;
		
		int i;
		if(exp>0)
		{
			for(i=0;i<exp;i++) {
				if(num>Long.MAX_VALUE/10 || num<Long.MIN_VALUE)
				{
					ShFloat n = ShFloat.getFloat(bak_num, exp);
					ShFloat d = ShFloat.getFloat(bak_den);
					return n.div(d);
				}
				num*=10;
			}
		}
		else
		{
			for(i=0;i>exp;i--)
			{
				if(den>Long.MAX_VALUE/10)
				{
					ShFloat n = ShFloat.getFloat(bak_num, exp);
					ShFloat d = ShFloat.getFloat(bak_den);
					return n.div(d);
				}
				den*=10;
			}
		}
		
		//qEő񐔂Ŋ
		g = gcd(num, den);
		num /= g;
		den /= g;
		
		//ShFractionŕ\邩m߂
		if(num<Integer.MIN_VALUE || num>Integer.MAX_VALUE || den<Integer.MIN_VALUE || den>Integer.MAX_VALUE)
		{
			//\Ȃ̂ŁAShFloatō쐬
			ShFloat n = ShFloat.getFloat(num);
			//ShFloat d = ShFloat.getFloat(den);
			return n.div(den);
		}
		return new ShFraction((int)num, (int)den);
	}

	/**
	 * thisnumber𑫂ʂԂB
	 * @param number 
	 * @return thisnumber𑫂
	 */
	public ShNumber add(ShNumber number)
	{
		if(number instanceof ShFraction)
		{
			return add((ShFraction)(number));
		}
		return number.add(this);
	}
	
	/**
	 * thisnumber𑫂ʂԂB
	 * @param number 
	 * @return thisnumber𑫂
	 */
	public ShReal add(ShReal number)
	{
		if(number instanceof ShFraction)
		{
			return add((ShFraction)(number));
		}
		return number.add(this);
	}
	
	/**
	 * thisnumber𑫂ʂԂB
	 * @param number 
	 * @return thisnumber𑫂
	 */
	public ShReal add(ShFraction number)
	{
		return addsub(number, 1);
	}
	
	/**
	 * thisnumberʂԂB
	 * @param number 
	 * @return thisnumber
	 */
	public ShNumber sub(ShNumber number)
	{
		if(number instanceof ShReal)
		{
			return sub((ShReal)number);
		}
		ShComplex c = toShComplex();
		return c.sub(number);
	}
	
	/**
	 * thisnumberʂԂB
	 * @param number 
	 * @return thisnumber
	 */
	public ShReal sub(ShReal number)
	{
		if(number instanceof ShFraction)
		{
			return sub((ShFraction)number);
		}
		ShFloat f = toShFloat();
		return f.sub(number);
	}
	
	/**
	 * thisnumberʂԂB
	 * @param number 
	 * @return thisnumber
	 */
	public ShReal sub(ShFraction number)
	{
		return addsub(number, -1);
	}
	
	/**
	 * s
	 *
	 * this + sign*numbervZ܂B
	 * sign̕ɂĉZƌẐǂvZł܂B
	 * @param number 鐔
	 * @param sign 
	 * @return this + sign*number\l
	 */
	public ShReal addsub(ShFraction number, int sign)
	{
		ShFloat f1, f2;
		long add_num;	//̕q
		int add_den;	//̕
		long out_num;	//ʂ̕q
		long out_den;	//ʂ̕
		long g;			//ő
		long tmp1, tmp2;
		
		out_num = num;
		out_den = den;
		add_num = number.num*sign;
		add_den = number.den;
		
		//ʕ
		g = gcd(out_den, add_den);
		tmp1 = add_den/g;
		tmp2 = out_den/g;
		
		//I[o[t[Ȃm߂
		if(Long.MAX_VALUE/tmp1<out_num || Long.MAX_VALUE/tmp1<out_den || Long.MAX_VALUE/tmp2<add_num)
		{
			//ł͕\Ȃ̂ŕ_ŌvZ
			f1 = toShFloat();
			f2 = number.toShFloat();
			return f1.addsub(f2, sign);
		}
		out_num *= tmp1;
		out_den *= tmp1;
		add_num *= tmp2;
		//add_den *= tmp; //gȂBout_denƈꏏɂȂ͂
		
		//vZ
		out_num += add_num;
		
		//ʂԂ
		return getFraction(out_num, out_den);
	}
	/**
	 * thisnumber|ʂԂB
	 * @param number |鐔
	 * @return thisnumber|
	 */
	public ShNumber mul(ShNumber number)
	{
		if(number instanceof ShFraction)
		{
			return mul((ShFraction)(number));
		}
		return number.mul(this);
	}
	
	/**
	 * thisnumber|ʂԂB
	 * @param number |鐔
	 * @return thisnumber|
	 */
	public ShReal mul(ShReal number)
	{
		if(number instanceof ShFraction)
		{
			return mul((ShFraction)(number));
		}
		return number.mul(this);
	}
	
	/**
	 * thisnumber|ʂԂB
	 * @param number |鐔
	 * @return thisnumber|
	 */
	public ShReal mul(ShFraction number)
	{
		return getFraction((long)num*number.num, (long)den*number.den);
	}
	
	/**
	 * thisnumberŊʂԂB
	 * @param number 鐔
	 * @return thisnumberŊl
	 */
	
	public ShNumber div(ShNumber number)
	{
		if(number instanceof ShReal)
		{
			return div((ShReal)number);
		}
		ShComplex c = toShComplex();
		return c.div(number);
	}
	
	/**
	 * thisnumberŊʂԂB
	 * @param number 鐔
	 * @return thisnumberŊl
	 */
	
	public ShReal div(ShReal number)
	{
		if(number instanceof ShFraction)
		{
			return div((ShFraction)number);
		}
		ShFloat f = toShFloat();
		return f.div(number);
	}

	/**
	 * thisnumberŊʂԂB
	 * @param number 鐔
	 * @return thisnumberŊl
	 */
	
	public ShReal div(ShFraction number)
	{
		return getFraction((long)num*number.den, (long)den*number.num);
	}
	
	public ShReal div(long number)
	{
		return getFraction(num, den*number);
	}
	
	/**
	 * ShFloat`ɕϊlԂB
	 * @return ̃IuWFNgShFloat`ɕϊl
	 */
	public ShFloat toShFloat()
	{
		ShFloat n = ShFloat.getFloat(num);
		return (ShFloat)(n.div(den));
	}
	
	/**
	 * ԂB
	 * @return Ȃ畉, Ȃ琳, 0Ȃ0ԂB
	 */
	public int sign()
	{
		return num;
	}
	
	public boolean equals(Object obj)
	{
		ShFraction f;
		if(obj instanceof ShFraction)
		{
			f = (ShFraction)obj;
			if(num==f.num && den==f.den)
			{
				return true;
			}
		}
		return false;
	}
	
	public int hashCode()
	{
		return num + den;
	}
	
	/**
	 * ő񐔂߂܂B
	 * @param a ő񐔂߂
	 * @param b ő񐔂߂
	 * @return ab̍ő
	 */
	public static long gcd(long a, long b)
	{
		long tmp;
		//ab1ȏɂ
		if(a==0 || b==0) return 1;
		if(a<0) a*=-1;
		if(b<0) b*=-1;
		
		while(b!=0)
		{
			a %= b;
			tmp = b;
			b = a;
			a = tmp;
		}
		return a;
	}
	
	/**
	 * ɕϊ
	 */
	public String toString()
	{
		return num + "/" + den;
	}
	
	public long toLong()
	{
		return toShFloat().toLong();
	}

	public long round()
	{
		return toShFloat().round();
	}
	
	public ShReal floor()
	{
		if(isInteger())
		{
			return this;
		}
		return toShFloat().floor();
	}
	
	public ShReal ceil()
	{
		if(isInteger())
		{
			return this;
		}
		return toShFloat().ceil();
	}
	
	public ShReal rint()
	{
		if(isInteger())
		{
			return this;
		}
		return toShFloat().rint();
	}
	
	public ShReal abs()
	{
		if(num<0)
		{
			return new ShFraction(-num, den);
		}
		return this;
	}
	
	public boolean isInteger()
	{
		return (den==1);
	}
}